package net.knarcraft.hungerarena.Listeners;

import net.knarcraft.hungerarena.HungerArena;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockFadeEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.player.PlayerBucketEmptyEvent;
import org.bukkit.event.player.PlayerBucketFillEvent;

import java.util.List;

public class BlockStorage implements Listener {
    public final HungerArena plugin;

    public BlockStorage(HungerArena m) {
        this.plugin = m;
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void BlockBreak(BlockBreakEvent event) {
        Block b = event.getBlock();
        Player p = event.getPlayer();
        String pname = p.getName();
        boolean alwaysProtect = false;
        if (!p.hasPermission("HungerArena.arena")) {
            alwaysProtect = alwaysProtect();
        }
        if ((plugin.getArena(p) != null) || (alwaysProtect)) {
            //Jeppa: get a default arena if always protect is true... (but use getArena if set...)
            int a = 1;
            if (alwaysProtect) {
                String ThisWorld = p.getWorld().getName();
                for (int z : plugin.worldsNames.keySet()) {
                    if (plugin.worldsNames.get(z) != null) {
                        if (plugin.worldsNames.get(z).equals(ThisWorld)) {
                            a = z;
                        }
                    }
                }
            }
            if (plugin.getArena(p) != null) {
                a = plugin.getArena(p);
            }
            if ((!event.isCancelled()) && (((plugin.Playing.get(a)).contains(pname)) || (alwaysProtect))) {
                if (plugin.config.getBoolean("Protected_Arena")) {
                    event.setCancelled(true);
                    p.sendMessage(ChatColor.RED + "You can't break blocks while playing!");
                } else if ((plugin.canJoin.get(a) || alwaysProtect) && ((!plugin.restrictedWorlds) || ((plugin.restrictedWorlds) && (plugin.worldsNames.containsValue(p.getWorld().getName()))))) {
                    if (((plugin.management.getStringList("blocks.whitelist").isEmpty()) || ((!plugin.management.getStringList("blocks.whitelist").isEmpty()) && (!plugin.management.getStringList("blocks.whitelist").contains(b.getType().name())))) ^ (plugin.management.getBoolean("blocks.useWhitelistAsBlacklist"))) {
                        event.setCancelled(true);
                        p.sendMessage(ChatColor.RED + "That is an illegal block!");
                    } else {
                        String w = b.getWorld().getName();
                        addDestroyedBlockToList(b, w, a);
                    }
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void Explosion(EntityExplodeEvent event) {
        List<Block> blocksd = event.blockList();
        Entity e = event.getEntity();
        if (!event.isCancelled()) {
            for (int i : plugin.canJoin.keySet()) {
                if (plugin.canJoin.get(i) || alwaysProtect()) {
                    String ThisWorld = e.getWorld().getName();
                    if ((!plugin.restrictedWorlds) || ((plugin.restrictedWorlds) && plugin.worldsNames.get(i) != null && plugin.worldsNames.get(i).equalsIgnoreCase(ThisWorld))) {
                        if (e.getType() == EntityType.PRIMED_TNT) {
                            e.getLocation().getBlock().setType(Material.TNT);
                            Block TNT = e.getLocation().getBlock();
                            addDestroyedBlockToList(TNT, ThisWorld, i);
                            TNT.setType(Material.AIR);
                        }
                        for (Block b : blocksd) {
                            if (!b.getType().name().equalsIgnoreCase("AIR")) {
                                addDestroyedBlockToList(b, ThisWorld, i);
                            }
                        }
                    }
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void burningBlocks(BlockBurnEvent event) {
        Block b = event.getBlock();
        if (!event.isCancelled()) {
            for (int i : plugin.canJoin.keySet()) {
                if (plugin.canJoin.get(i) || alwaysProtect()) {
                    if ((!plugin.restrictedWorlds) || ((plugin.restrictedWorlds) && (plugin.worldsNames.get(i) != null && plugin.worldsNames.get(i).equalsIgnoreCase(b.getWorld().getName())))) {
                        String w = b.getWorld().getName();
                        addDestroyedBlockToList(b, w, i);
                    }
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void blockPlace(BlockPlaceEvent event) {
        Block b = event.getBlock();
        Player p = event.getPlayer();
        boolean protall = false;
        if (!p.hasPermission("HungerArena.arena")) {
            protall = alwaysProtect();
        }
        if ((plugin.getArena(p) != null) || (protall)) {
            int a = 1;
            if (protall) {
                String ThisWorld = p.getWorld().getName();
                for (int z : plugin.worldsNames.keySet()) {
                    if (plugin.worldsNames.get(z) != null) {
                        if (plugin.worldsNames.get(z).equals(ThisWorld)) {
                            a = z;
                        }
                    }
                }
            }
            if (plugin.getArena(p) != null) {
                a = plugin.getArena(p);
            }
            if (!event.isCancelled()) {
                if (((plugin.Playing.get(a)).contains(p.getName())) || (protall)) {
                    if ((plugin.canJoin.get(a)) || (protall)) {
                        if ((!plugin.restrictedWorlds) || ((plugin.restrictedWorlds) && (plugin.worldsNames.containsValue(b.getWorld().getName())))) {
                            if ((b.getType() == Material.SAND || b.getType() == Material.GRAVEL) && (b.getRelative(BlockFace.DOWN).getType() == Material.AIR || b.getRelative(BlockFace.DOWN).getType() == Material.WATER || b.getRelative(BlockFace.DOWN).getType() == Material.LAVA)) {
                                int n = b.getY() - 1;
                                while (b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() == Material.AIR || b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() == Material.WATER || b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() == Material.LAVA) {
                                    n = n - 1;
                                    event.getPlayer().sendMessage(b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType().toString().toLowerCase());
                                    if (b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() != Material.AIR || b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() != Material.WATER || b.getWorld().getBlockAt(b.getX(), n, b.getZ()).getType() != Material.LAVA) {
                                        int l = n + 1;
                                        Block br = b.getWorld().getBlockAt(b.getX(), l, b.getZ());
                                        String w = br.getWorld().getName();

                                        addPlacedBlockToList(br, w, a);
                                    }
                                }
                            } else {
                                if (b.getType() != Material.SAND && b.getType() != Material.GRAVEL) {
                                    String w = b.getWorld().getName();

                                    addPlacedBlockToList(b, w, a);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void bucketEmpty(PlayerBucketEmptyEvent event) {
        if (plugin.getArena(event.getPlayer()) != null) {
            int a = plugin.getArena(event.getPlayer());
            if (!event.isCancelled()) {
                if (plugin.canJoin.get(a)) {
                    if (plugin.Playing.get(a).contains(event.getPlayer().getName())) {
                        if ((!plugin.restrictedWorlds) || ((plugin.restrictedWorlds) && (plugin.worldsNames.containsValue(event.getPlayer().getWorld().getName())))) {
                            Block b = event.getBlockClicked().getRelative(event.getBlockFace());
                            String w = b.getWorld().getName();
                            addPlacedBlockToList(b, w, a);
                        }
                    }
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void bucketFill(PlayerBucketFillEvent event) {
        if (plugin.getArena(event.getPlayer()) != null) {
            int arena = plugin.getArena(event.getPlayer());
            if (event.isCancelled()) {
                return;
            }
            boolean isPlaying = plugin.Playing.get(arena).contains(event.getPlayer().getName());
            boolean enabledInWorld = plugin.worldsNames.containsValue(event.getPlayer().getWorld().getName());
            
            if (joinAble(arena) && (isPlaying && (!plugin.restrictedWorlds || enabledInWorld))) {
                Block block = event.getBlockClicked().getRelative(event.getBlockFace());
                String worldName = block.getWorld().getName();
                addDestroyedBlockToList(block, worldName, arena);
            }
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void blockMelt(BlockFadeEvent event) {
        if (event.isCancelled()) {
            return;
        }

        for (int arena : plugin.canJoin.keySet()) {
            boolean isInWorld = plugin.worldsNames.get(arena).equalsIgnoreCase(event.getBlock().getWorld().getName());
            if (joinAble(arena) || alwaysProtect() && 
                    (!plugin.restrictedWorlds || plugin.worldsNames.get(arena) != null && isInWorld)) {
                Block block = event.getBlock();
                String worldName = block.getWorld().getName();
                Material material = block.getType();
                if (material == Material.FIRE || material.isAir()) {
                    continue;
                }
                addDestroyedBlockToList(block, worldName, arena);
            }
        }
    }

    //SubRoutines:
    private boolean alwaysProtect() {
        return plugin.config.getBoolean("Protected_Arena_Always");
    }

    private void addDestroyedBlockToList(Block block, String worldName, int arena) {
        int x = block.getX();
        int y = block.getY();
        int z = block.getZ();
        String d = block.getType().name();
        String blockDataString;
        String splitter = ";";

        String direction = "";
        block.getState().getBlockData();
        blockDataString = block.getBlockData().getAsString();
        String coordinates = worldName + splitter + x + splitter + y + splitter + z + splitter + d + splitter +
                blockDataString + splitter + arena + direction;
        List<String> blocks = plugin.data.getStringList("Blocks_Destroyed");
        if (!plugin.data.getStringList("Blocks_Placed").contains(String.format("%s,%d,%d,%d,%s", worldName, x, y, z, arena))) {
            blocks.add(coordinates);
            plugin.data.set("Blocks_Destroyed", blocks);
            plugin.saveData();
        }
    }

    private void addPlacedBlockToList(Block block, String worldName, int arena) {
        int x = block.getX();
        int y = block.getY();
        int z = block.getZ();
        String coordinates = String.format("%s,%d,%d,%d,%d", worldName, x, y, z, arena);
        List<String> blocks = plugin.data.getStringList("Blocks_Placed");
        if (!blocks.contains(coordinates)) {
            blocks.add(coordinates);
            plugin.data.set("Blocks_Placed", blocks);
            plugin.saveData();
        }
    }

    /**
     * Gets whether the given arena can be joined
     * 
     * @param arena <p>The arena to check</p>
     * @return <p>True if the arena can be joined</p>
     */
    private boolean joinAble(int arena) {
        return plugin.canJoin.get(arena);
    }

}