package net.knarcraft.hungerarena.Listeners;

import net.knarcraft.hungerarena.HaCommands;
import net.knarcraft.hungerarena.HungerArena;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.scoreboard.DisplaySlot;

public class JoinAndQuitListener implements Listener {
    public HungerArena plugin;

    public JoinAndQuitListener(HungerArena m) {
        this.plugin = m;
    }

    public HaCommands commands;

    public JoinAndQuitListener(HaCommands h) {
        this.commands = h;
    }

    int arena = 0;

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        final Player player = event.getPlayer();
        final String pname = player.getName();
        boolean pfound = false;
        for (int i : plugin.Watching.keySet()) {
            for (String s : plugin.Watching.get(i)) {
                Player spectator = plugin.getServer().getPlayerExact(s);
                player.hidePlayer(plugin, spectator);
            }
        }
        for (int i : plugin.Out.keySet()) {
            if (plugin.Out.get(i).contains(pname)) {
                plugin.Playing.get(i).add(pname);
                plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> player.sendMessage(ChatColor.AQUA + "You have saved yourself from being ejected from the arena!"), 40L);
                plugin.Out.get(i).remove(pname);
                pfound = true;
            }
        }

        for (final int i : plugin.Quit.keySet()) {
            if (plugin.Quit.get(i).contains(pname)) {
                String[] Spawncoords = plugin.spawns.getString("Spawn_coordinates." + i).split(",");
                String w = Spawncoords[3];
                World spawnw = plugin.getServer().getWorld(w);
                double spawnx = Double.parseDouble(Spawncoords[0]);
                double spawny = Double.parseDouble(Spawncoords[1]);
                double spawnz = Double.parseDouble(Spawncoords[2]);
                final Location Spawn = new Location(spawnw, spawnx, spawny, spawnz);
                plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                    player.teleport(Spawn);
                    player.sendMessage(ChatColor.RED + "You have been teleported to last spawn because you quit/forfeited!");
                    plugin.RestoreInv(player, player.getName());
                    if (plugin.Quit.get(i) != null) {
                        plugin.Quit.get(i).remove(player.getName());
                    }
                }, 40L);
                pfound = true;
            }
        }
        for (final int i : plugin.Dead.keySet()) {
            if (plugin.Dead.get(i).contains(pname)) {
                String[] Spawncoords = plugin.spawns.getString("Spawn_coordinates." + i).split(",");
                String w = Spawncoords[3];
                World spawnw = plugin.getServer().getWorld(w);
                double spawnx = Double.parseDouble(Spawncoords[0]);
                double spawny = Double.parseDouble(Spawncoords[1]);
                double spawnz = Double.parseDouble(Spawncoords[2]);
                final Location Spawn = new Location(spawnw, spawnx, spawny, spawnz);
                plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                    player.teleport(Spawn);
                    player.sendMessage(ChatColor.RED + "You have been teleported to spawn because you quit/died/forfeited!!");
                    plugin.RestoreInv(player, player.getName());
                    if (plugin.Dead.get(i) != null) {
                        plugin.Dead.get(i).remove(player.getName());
                    }
                }, 40L);
                pfound = true;
            }
        }
        for (final int i : plugin.inArena.keySet()) {
            if (plugin.inArena.get(i) != null) {
                if (plugin.inArena.get(i).contains(pname)) {
                    String[] Spawncoords = plugin.spawns.getString("Spawn_coordinates." + i).split(",");
                    String w = Spawncoords[3];
                    World spawnw = plugin.getServer().getWorld(w);
                    double spawnx = Double.parseDouble(Spawncoords[0]);
                    double spawny = Double.parseDouble(Spawncoords[1]);
                    double spawnz = Double.parseDouble(Spawncoords[2]);
                    final Location Spawn = new Location(spawnw, spawnx, spawny, spawnz);
                    plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                        player.teleport(Spawn);
                        player.getInventory().clear();
                        player.getInventory().setBoots(null);
                        player.getInventory().setLeggings(null);
                        player.getInventory().setChestplate(null);
                        player.getInventory().setHelmet(null);
                        plugin.inArena.remove(pname);
                        player.sendMessage(ChatColor.RED + "You were still in the arena when you left and now the games are over.");
                        plugin.RestoreInv(player, player.getName());
                        if (plugin.inArena.get(i) != null) {
                            plugin.inArena.get(i).remove(player.getName());
                        }
                    }, 40L);
                    pfound = true;
                }
            }
        }
        if (!plugin.restrictedWorlds || plugin.worldsNames.containsValue(player.getWorld().getName())) {
            if (!pfound && plugin.config.getBoolean("Force_Players_toSpawn") && (plugin.spawns.getString("Spawn_coordinates.0") != null)) {
                String[] spawnCoordinates = plugin.spawns.getString("Spawn_coordinates.0").split(",");
                String w = spawnCoordinates[3];
                World spawnWorld = plugin.getServer().getWorld(w);
                double spawnX = Double.parseDouble(spawnCoordinates[0]);
                double spawnY = Double.parseDouble(spawnCoordinates[1]);
                double spawnZ = Double.parseDouble(spawnCoordinates[2]);
                final Location Spawn = new Location(spawnWorld, spawnX, spawnY, spawnZ);
                plugin.RestoreInv(player, player.getName());
                plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                    player.teleport(Spawn);
                    player.sendMessage(ChatColor.RED + "You have been teleported to spawn!!");
                }, 40L);
            }
        }
    }

    @EventHandler
    public void onQuit(PlayerQuitEvent evt) {
        Player p = evt.getPlayer();
        String playerName = p.getName();
        for (int i : plugin.Frozen.keySet()) {
            if (plugin.Frozen.get(i).contains(playerName)) {
                plugin.Frozen.remove(playerName);
                String[] Spawncoords = plugin.spawns.getString("Spawn_coordinates.0").split(",");
                String w = Spawncoords[3];
                World spawnw = plugin.getServer().getWorld(w);
                double spawnx = Double.parseDouble(Spawncoords[0]);
                double spawny = Double.parseDouble(Spawncoords[1]);
                double spawnz = Double.parseDouble(Spawncoords[2]);
                Location Spawn = new Location(spawnw, spawnx, spawny, spawnz);
                p.teleport(Spawn);
                p.getScoreboard().clearSlot(DisplaySlot.SIDEBAR);
                plugin.scoreboards.remove(p.getName());
                plugin.Kills.remove(p.getName());
            }
        }
    }

    @EventHandler
    public void onPlayerQuit(PlayerQuitEvent event) {
        final Player p = event.getPlayer();
        final String playerName = p.getName();
        if (plugin.getArena(p) != null) {
            arena = plugin.getArena(p);
            plugin.Out.get(arena).add(playerName);
            plugin.Playing.get(arena).remove(playerName);
            plugin.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                if (plugin.Out.get(arena).contains(playerName)) {
                    plugin.Quit.get(arena).add(playerName);
                    plugin.Out.get(arena).remove(playerName);
                    p.getScoreboard().clearSlot(DisplaySlot.SIDEBAR);
                    plugin.scoreboards.remove(p.getName());
                    plugin.Kills.remove(p.getName());
                    plugin.winner(arena);
                    plugin.inArena.get(arena).add(playerName);
                } else if (plugin.getArena(p) == null) {
                    plugin.Quit.get(arena).add(playerName);
                }
            }, 1200L);
        }
    }
}
