package net.knarcraft.hungerarena;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.HashMap;

public class SpawnsCommand implements CommandExecutor {
    public final HungerArena plugin;
    int i = 0;
    int arenaId = 0;
    boolean NoPlayerSpawns;

    public SpawnsCommand(HungerArena m) {
        this.plugin = m;
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command cmd, @NotNull String commandLabel, String[] args) {
        Player p = (Player) sender;
        String ThisWorld = p.getWorld().getName();
        NoPlayerSpawns = true;
        for (int i : plugin.worldsNames.keySet()) {
            if (plugin.worldsNames.get(i) != null) {
                if (plugin.worldsNames.get(i).equals(ThisWorld)) {
                    arenaId = i;
                    NoPlayerSpawns = false;
                    break;
                }
            }
        }
        if (cmd.getName().equalsIgnoreCase("StartPoint")) {
            if (p.hasPermission("HungerArena.StartPoint")) {
                Location location;
                double x;
                double y;
                double z;
                if (args.length == 6) {
                    try {
                        i = Integer.parseInt(args[1]);
                        arenaId = Integer.parseInt(args[0]);
                    } catch (Exception e) {
                        p.sendMessage(ChatColor.RED + "Argument not an integer!");
                        return true;
                    }

                    String world = args[2];
                    x = Double.parseDouble(args[3]);
                    y = Double.parseDouble(args[4]);
                    z = Double.parseDouble(args[5]);
                    location = new Location(Bukkit.getWorld(world), x, y, z);
                    if (plugin.location.get(arenaId) != null) {
                        plugin.location.get(arenaId).put(i, location);
                    } else {
                        /*plugin.arenas.put(arenaId, new Arena(arenaId, location.getWorld(), new ArrayList<>(), 
                                ArenaState.IDLE, false, true, 0, 0, 0, 
                                new HashMap<>()));*/
                        plugin.arenas.get(arenaId).locations().put(i, location);
                        plugin.location.put(arenaId, new HashMap<>());
                        plugin.location.get(arenaId).put(i, location);
                        plugin.Playing.put(arenaId, new ArrayList<>());
                        plugin.Ready.put(arenaId, new ArrayList<>());
                        plugin.Dead.put(arenaId, new ArrayList<>());
                        plugin.Quit.put(arenaId, new ArrayList<>());
                        plugin.Out.put(arenaId, new ArrayList<>());
                        plugin.Watching.put(arenaId, new ArrayList<>());
                        plugin.NeedConfirm.put(arenaId, new ArrayList<>());
                        plugin.inArena.put(arenaId, new ArrayList<>());
                        plugin.Frozen.put(arenaId, new ArrayList<>());
                        plugin.canJoin.put(arenaId, false);
                        plugin.MatchRunning.put(arenaId, null);
                        plugin.open.put(arenaId, true);
                    }
                    String coords = location.getWorld().getName() + "," + (location.getX()) + "," + location.getY() + "," + (location.getZ());
                    p.sendMessage(coords);
                    plugin.spawns.set("Spawns." + arenaId + "" + i, coords);
                    plugin.worldsNames.put(arenaId, location.getWorld().getName());
                    plugin.saveSpawns();
                    plugin.maxPlayers.put(arenaId, plugin.location.get(arenaId).size());
                    p.sendMessage(ChatColor.AQUA + "You have set the spawn location of Tribute " + i + " in arena " + arenaId + "!");
                    this.plugin.reloadSpawnPoints(false);
                    return true;
                }
                if (args.length >= 2) {
                    try {
                        i = Integer.parseInt(args[1]);
                        arenaId = Integer.parseInt(args[0]);
                    } catch (Exception e) {
                        p.sendMessage(ChatColor.RED + "Argument not an integer!");
                        return true;
                    }
                    if (i >= 1 && i <= plugin.config.getInt("maxPlayers")) {
                        if (!plugin.worldsNames.containsValue(p.getWorld().getName())) {
                            p.sendMessage(ChatColor.GOLD + "You've added this world to the config ...");
                        }
                        location = p.getLocation().getBlock().getLocation();
                        x = location.getX() + .5;
                        y = location.getY();
                        z = location.getZ() + .5;
                        location = new Location(location.getWorld(), x, y, z);
                        if (plugin.location.get(arenaId) != null) {
                            plugin.location.get(arenaId).put(i, location);
                        } else {
                            plugin.location.put(arenaId, new HashMap<>());
                            plugin.location.get(arenaId).put(i, location);
                            plugin.Playing.put(arenaId, new ArrayList<>());
                            plugin.Ready.put(arenaId, new ArrayList<>());
                            plugin.Dead.put(arenaId, new ArrayList<>());
                            plugin.Quit.put(arenaId, new ArrayList<>());
                            plugin.Out.put(arenaId, new ArrayList<>());
                            plugin.Watching.put(arenaId, new ArrayList<>());
                            plugin.NeedConfirm.put(arenaId, new ArrayList<>());
                            plugin.inArena.put(arenaId, new ArrayList<>());
                            plugin.Frozen.put(arenaId, new ArrayList<>());
                            plugin.canJoin.put(arenaId, false);
                            plugin.MatchRunning.put(arenaId, null);
                            plugin.open.put(arenaId, true);
                        }
                        String coords = location.getWorld().getName() + "," + (location.getX()) + "," + location.getY() + "," + (location.getZ());
                        p.sendMessage(coords);
                        plugin.spawns.set("Spawns." + arenaId + "" + i, coords);
                        plugin.worldsNames.put(arenaId, location.getWorld().getName());
                        plugin.saveSpawns();
                        plugin.maxPlayers.put(arenaId, plugin.location.get(arenaId).size());
                        p.sendMessage(ChatColor.AQUA + "You have set the spawn location of Tribute " + i + " in arena " + arenaId + "!");
                        this.plugin.reloadSpawnPoints(false);
                    } else {
                        p.sendMessage(ChatColor.RED + "You can't go past " + plugin.config.getInt("maxPlayers") + " players!");
                    }
                } else if (args.length == 1) {
                    if (NoPlayerSpawns) {
                        try {
                            arenaId = Integer.parseInt(args[0]);
                        } catch (Exception e) {
                            p.sendMessage(ChatColor.RED + "Argument not an integer!");
                            return true;
                        }
                    }
                    if (plugin.spawns.get("Spawns." + arenaId) != null) {
                        int start = 1;
                        while (start < plugin.config.getInt("maxPlayers") + 2) {
                            if (plugin.spawns.get("Spawns." + arenaId + "" + start) != null) {
                                start = start + 1;
                                if (start == plugin.config.getInt("maxPlayers") + 1) {
                                    p.sendMessage(ChatColor.DARK_AQUA + "[HungerArena] " + ChatColor.GREEN + "All spawns set, type /startpoint [Arena #] [Spawn #] to over-ride previous points!");
                                    return true;
                                }
                            } else {
                                int sloc = start;
                                start = plugin.config.getInt("maxPlayers") + 1;
                                p.sendMessage(ChatColor.DARK_AQUA + "[HungerArena] " + ChatColor.RED + "Begin Setting For Arena " + arenaId + " Starting From Point " + sloc);
                                plugin.setting.put(p.getName(), arenaId + "-" + sloc);
                                return true;
                            }
                        }
                    }
                    p.sendMessage(ChatColor.DARK_AQUA + "[HungerArena] " + ChatColor.RED + "Begin Setting For Arena " + arenaId + " Starting From Point " + 1);
                    plugin.setting.put(p.getName(), arenaId + "-" + 1);
                    return true;
                } else {
                    p.sendMessage(ChatColor.RED + "No argument given! \nUse command like this:\n/startpoint [Arena #] [Startpoint #] for setting your position as a startpoint.\n/startpoint [Arena #] [Startpoint #] [Mapname] [x] [y] [z] \nOr you can use /startpoint [Arena #] to use the 'spawntool': ID" + plugin.config.getInt("spawnsTool") + " for setting the startpoints!");
                    return false;
                }
            } else {
                p.sendMessage(ChatColor.RED + "You don't have permission!");
            }
        }
        return false;
    }

}
